# coding: utf-8

"""
    Billing API

    Billing API allows users to retrieve billing reports and service package details.

    OpenAPI spec version: 1.4.7
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ServicePackageQuotaHistoryReservation(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'str',
        'campaign_name': 'str',
        'id': 'str'
    }

    attribute_map = {
        'account_id': 'account_id',
        'campaign_name': 'campaign_name',
        'id': 'id'
    }

    def __init__(self, account_id=None, campaign_name=None, id=None):
        """
        ServicePackageQuotaHistoryReservation - a model defined in Swagger
        """

        self._account_id = account_id
        self._campaign_name = campaign_name
        self._id = id
        self.discriminator = None

    @property
    def account_id(self):
        """
        Gets the account_id of this ServicePackageQuotaHistoryReservation.
        Account ID.

        :return: The account_id of this ServicePackageQuotaHistoryReservation.
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """
        Sets the account_id of this ServicePackageQuotaHistoryReservation.
        Account ID.

        :param account_id: The account_id of this ServicePackageQuotaHistoryReservation.
        :type: str
        """
        if account_id is None:
            raise ValueError("Invalid value for `account_id`, must not be `None`")
        if account_id is not None and len(account_id) > 250:
            raise ValueError("Invalid value for `account_id`, length must be less than or equal to `250`")
        if account_id is not None and len(account_id) < 1:
            raise ValueError("Invalid value for `account_id`, length must be greater than or equal to `1`")

        self._account_id = account_id

    @property
    def campaign_name(self):
        """
        Gets the campaign_name of this ServicePackageQuotaHistoryReservation.
        Textual campaign name for this reservation.

        :return: The campaign_name of this ServicePackageQuotaHistoryReservation.
        :rtype: str
        """
        return self._campaign_name

    @campaign_name.setter
    def campaign_name(self, campaign_name):
        """
        Sets the campaign_name of this ServicePackageQuotaHistoryReservation.
        Textual campaign name for this reservation.

        :param campaign_name: The campaign_name of this ServicePackageQuotaHistoryReservation.
        :type: str
        """
        if campaign_name is None:
            raise ValueError("Invalid value for `campaign_name`, must not be `None`")
        if campaign_name is not None and len(campaign_name) > 250:
            raise ValueError("Invalid value for `campaign_name`, length must be less than or equal to `250`")
        if campaign_name is not None and len(campaign_name) < 1:
            raise ValueError("Invalid value for `campaign_name`, length must be greater than or equal to `1`")

        self._campaign_name = campaign_name

    @property
    def id(self):
        """
        Gets the id of this ServicePackageQuotaHistoryReservation.
        Reservation ID.

        :return: The id of this ServicePackageQuotaHistoryReservation.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ServicePackageQuotaHistoryReservation.
        Reservation ID.

        :param id: The id of this ServicePackageQuotaHistoryReservation.
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")
        if id is not None and len(id) > 250:
            raise ValueError("Invalid value for `id`, length must be less than or equal to `250`")
        if id is not None and len(id) < 1:
            raise ValueError("Invalid value for `id`, length must be greater than or equal to `1`")

        self._id = id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ServicePackageQuotaHistoryReservation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
