# connector-bootstrap
Bootstrap API allows web applications to control the device bootstrapping process.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import connector_bootstrap 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import connector_bootstrap
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import connector_bootstrap
from connector_bootstrap.rest import ApiException
from pprint import pprint

# Configure API key authorization: Bearer
connector_bootstrap.configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# connector_bootstrap.configuration.api_key_prefix['Authorization'] = 'Bearer'
# create an instance of the API class
api_instance = connector_bootstrap.PreSharedKeysApi()
endpoint_name = 'endpoint_name_example' # str | The unique endpoint identifier that this pre-shared key applies to. [Reserved characters](https://en.wikipedia.org/wiki/Percent-encoding#Percent-encoding_reserved_characters) must be percent-encoded.

try:
    # Remove a pre-shared key.
    api_instance.delete_pre_shared_key(endpoint_name)
except ApiException as e:
    print("Exception when calling PreSharedKeysApi->delete_pre_shared_key: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.us-east-1.mbedcloud.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*PreSharedKeysApi* | [**delete_pre_shared_key**](docs/PreSharedKeysApi.md#delete_pre_shared_key) | **DELETE** /v2/device-shared-keys/{endpoint_name} | Remove a pre-shared key.
*PreSharedKeysApi* | [**get_pre_shared_key**](docs/PreSharedKeysApi.md#get_pre_shared_key) | **GET** /v2/device-shared-keys/{endpoint_name} | Get a pre-shared key.
*PreSharedKeysApi* | [**list_pre_shared_keys**](docs/PreSharedKeysApi.md#list_pre_shared_keys) | **GET** /v2/device-shared-keys | List pre-shared keys.
*PreSharedKeysApi* | [**upload_pre_shared_key**](docs/PreSharedKeysApi.md#upload_pre_shared_key) | **POST** /v2/device-shared-keys | Upload a pre-shared key to Pelion Device Management.


## Documentation For Models

 - [ListOfPreSharedKeysWithoutSecret](docs/ListOfPreSharedKeysWithoutSecret.md)
 - [PreSharedKey](docs/PreSharedKey.md)
 - [PreSharedKeyWithoutSecret](docs/PreSharedKeyWithoutSecret.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author



