# coding: utf-8

"""
    Device Directory API

    This is the API Documentation for the Device Directory service.

    OpenAPI spec version: 3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class DeviceGroup(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'created_at': 'datetime',
        'custom_attributes': 'dict(str, str)',
        'description': 'str',
        'devices_count': 'int',
        'etag': 'datetime',
        'id': 'str',
        'name': 'str',
        'object': 'str',
        'updated_at': 'datetime'
    }

    attribute_map = {
        'created_at': 'created_at',
        'custom_attributes': 'custom_attributes',
        'description': 'description',
        'devices_count': 'devices_count',
        'etag': 'etag',
        'id': 'id',
        'name': 'name',
        'object': 'object',
        'updated_at': 'updated_at'
    }

    def __init__(self, created_at=None, custom_attributes=None, description=None, devices_count=None, etag=None, id=None, name=None, object=None, updated_at=None):
        """
        DeviceGroup - a model defined in Swagger
        """

        self._created_at = created_at
        self._custom_attributes = custom_attributes
        self._description = description
        self._devices_count = devices_count
        self._etag = etag
        self._id = id
        self._name = name
        self._object = object
        self._updated_at = updated_at
        self.discriminator = None

    @property
    def created_at(self):
        """
        Gets the created_at of this DeviceGroup.
        The time the campaign was created

        :return: The created_at of this DeviceGroup.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """
        Sets the created_at of this DeviceGroup.
        The time the campaign was created

        :param created_at: The created_at of this DeviceGroup.
        :type: datetime
        """

        self._created_at = created_at

    @property
    def custom_attributes(self):
        """
        Gets the custom_attributes of this DeviceGroup.
        Up to ten custom key-value attributes.

        :return: The custom_attributes of this DeviceGroup.
        :rtype: dict(str, str)
        """
        return self._custom_attributes

    @custom_attributes.setter
    def custom_attributes(self, custom_attributes):
        """
        Sets the custom_attributes of this DeviceGroup.
        Up to ten custom key-value attributes.

        :param custom_attributes: The custom_attributes of this DeviceGroup.
        :type: dict(str, str)
        """

        self._custom_attributes = custom_attributes

    @property
    def description(self):
        """
        Gets the description of this DeviceGroup.
        The description of the group

        :return: The description of this DeviceGroup.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this DeviceGroup.
        The description of the group

        :param description: The description of this DeviceGroup.
        :type: str
        """
        if description is not None and len(description) > 2000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `2000`")

        self._description = description

    @property
    def devices_count(self):
        """
        Gets the devices_count of this DeviceGroup.
        The number of devices in this group

        :return: The devices_count of this DeviceGroup.
        :rtype: int
        """
        return self._devices_count

    @devices_count.setter
    def devices_count(self, devices_count):
        """
        Sets the devices_count of this DeviceGroup.
        The number of devices in this group

        :param devices_count: The devices_count of this DeviceGroup.
        :type: int
        """

        self._devices_count = devices_count

    @property
    def etag(self):
        """
        Gets the etag of this DeviceGroup.

        :return: The etag of this DeviceGroup.
        :rtype: datetime
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """
        Sets the etag of this DeviceGroup.

        :param etag: The etag of this DeviceGroup.
        :type: datetime
        """

        self._etag = etag

    @property
    def id(self):
        """
        Gets the id of this DeviceGroup.
        The group id

        :return: The id of this DeviceGroup.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this DeviceGroup.
        The group id

        :param id: The id of this DeviceGroup.
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """
        Gets the name of this DeviceGroup.
        Name of the group

        :return: The name of this DeviceGroup.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this DeviceGroup.
        Name of the group

        :param name: The name of this DeviceGroup.
        :type: str
        """
        if name is not None and len(name) > 128:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `128`")

        self._name = name

    @property
    def object(self):
        """
        Gets the object of this DeviceGroup.
        Entity name: always 'device-group'

        :return: The object of this DeviceGroup.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object):
        """
        Sets the object of this DeviceGroup.
        Entity name: always 'device-group'

        :param object: The object of this DeviceGroup.
        :type: str
        """

        self._object = object

    @property
    def updated_at(self):
        """
        Gets the updated_at of this DeviceGroup.
        The time the object was updated

        :return: The updated_at of this DeviceGroup.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """
        Sets the updated_at of this DeviceGroup.
        The time the object was updated

        :param updated_at: The updated_at of this DeviceGroup.
        :type: datetime
        """

        self._updated_at = updated_at

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, DeviceGroup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
