# external-ca
API for managing third party CA for creating certificates on Pelion Device Management

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v3
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import external_ca 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import external_ca
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import external_ca
from external_ca.rest import ApiException
from pprint import pprint

# Configure API key authorization: Bearer
external_ca.configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# external_ca.configuration.api_key_prefix['Authorization'] = 'Bearer'
# create an instance of the API class
api_instance = external_ca.CertificateIssuersApi()
certificate_issuer_request = external_ca.CertificateIssuerRequest() # CertificateIssuerRequest | Certificate issuer request.

try:
    # Create certificate issuer.
    api_response = api_instance.create_certificate_issuer(certificate_issuer_request)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificateIssuersApi->create_certificate_issuer: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.us-east-1.mbedcloud.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CertificateIssuersApi* | [**create_certificate_issuer**](docs/CertificateIssuersApi.md#create_certificate_issuer) | **POST** /v3/certificate-issuers | Create certificate issuer.
*CertificateIssuersApi* | [**delete_certificate_issuer**](docs/CertificateIssuersApi.md#delete_certificate_issuer) | **DELETE** /v3/certificate-issuers/{certificate-issuer-id} | Delete certificate issuer.
*CertificateIssuersApi* | [**get_certificate_issuer**](docs/CertificateIssuersApi.md#get_certificate_issuer) | **GET** /v3/certificate-issuers/{certificate-issuer-id} | Get certificate issuer by ID.
*CertificateIssuersApi* | [**get_certificate_issuers**](docs/CertificateIssuersApi.md#get_certificate_issuers) | **GET** /v3/certificate-issuers | Get certificate issuers list.
*CertificateIssuersApi* | [**update_certificate_issuer**](docs/CertificateIssuersApi.md#update_certificate_issuer) | **PUT** /v3/certificate-issuers/{certificate-issuer-id} | Update certificate issuer.
*CertificateIssuersApi* | [**verify_certificate_issuer**](docs/CertificateIssuersApi.md#verify_certificate_issuer) | **POST** /v3/certificate-issuers/{certificate-issuer-id}/verify | Verify certificate issuer.
*CertificateIssuersActivationApi* | [**create_certificate_issuer_config**](docs/CertificateIssuersActivationApi.md#create_certificate_issuer_config) | **POST** /v3/certificate-issuer-configurations | Create certificate issuer configuration.
*CertificateIssuersActivationApi* | [**delete_certificate_issuer_config_by_id**](docs/CertificateIssuersActivationApi.md#delete_certificate_issuer_config_by_id) | **DELETE** /v3/certificate-issuer-configurations/{certificate-issuer-configuration-id} | Delete certificate issuer configuration.
*CertificateIssuersActivationApi* | [**get_certificate_issuer_config**](docs/CertificateIssuersActivationApi.md#get_certificate_issuer_config) | **GET** /v3/certificate-issuer-configurations/lwm2m | Get certificate issuer configuration.
*CertificateIssuersActivationApi* | [**get_certificate_issuer_config_by_id**](docs/CertificateIssuersActivationApi.md#get_certificate_issuer_config_by_id) | **GET** /v3/certificate-issuer-configurations/{certificate-issuer-configuration-id} | Get certificate issuer configuration.
*CertificateIssuersActivationApi* | [**get_certificate_issuer_configs**](docs/CertificateIssuersActivationApi.md#get_certificate_issuer_configs) | **GET** /v3/certificate-issuer-configurations | Get certificate issuer configurations.
*CertificateIssuersActivationApi* | [**update_certificate_issuer_config**](docs/CertificateIssuersActivationApi.md#update_certificate_issuer_config) | **PUT** /v3/certificate-issuer-configurations/lwm2m | Update certificate issuer configuration.
*CertificateIssuersActivationApi* | [**update_certificate_issuer_config_by_id**](docs/CertificateIssuersActivationApi.md#update_certificate_issuer_config_by_id) | **PUT** /v3/certificate-issuer-configurations/{certificate-issuer-configuration-id} | Update certificate issuer configuration.


## Documentation For Models

 - [CertificateIssuerConfigListResponse](docs/CertificateIssuerConfigListResponse.md)
 - [CertificateIssuerConfigRequest](docs/CertificateIssuerConfigRequest.md)
 - [CertificateIssuerConfigResponse](docs/CertificateIssuerConfigResponse.md)
 - [CertificateIssuerInfo](docs/CertificateIssuerInfo.md)
 - [CertificateIssuerInfoListResponse](docs/CertificateIssuerInfoListResponse.md)
 - [CertificateIssuerRequest](docs/CertificateIssuerRequest.md)
 - [CertificateIssuerUpdateRequest](docs/CertificateIssuerUpdateRequest.md)
 - [CertificateIssuerVerifyResponse](docs/CertificateIssuerVerifyResponse.md)
 - [CfsslAttributes](docs/CfsslAttributes.md)
 - [CfsslAuthCredentials](docs/CfsslAuthCredentials.md)
 - [CreateCertificateIssuerConfig](docs/CreateCertificateIssuerConfig.md)
 - [ErrorObjectResponse](docs/ErrorObjectResponse.md)
 - [FieldMessageEntry](docs/FieldMessageEntry.md)
 - [GlobalSignCredentials](docs/GlobalSignCredentials.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author



