# coding: utf-8

"""
    Update Service API

    This is the API documentation for the Device Management deployment service, which is part of the Update service.

    OpenAPI spec version: 3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class UploadChunkInfo(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'created_at': 'datetime',
        'etag': 'str',
        'hash': 'str',
        'id': 'int',
        'length': 'int',
        'object': 'str',
        'status': 'str',
        'updated_at': 'datetime'
    }

    attribute_map = {
        'created_at': 'created_at',
        'etag': 'etag',
        'hash': 'hash',
        'id': 'id',
        'length': 'length',
        'object': 'object',
        'status': 'status',
        'updated_at': 'updated_at'
    }

    def __init__(self, created_at=None, etag=None, hash=None, id=None, length=None, object=None, status=None, updated_at=None):
        """
        UploadChunkInfo - a model defined in Swagger
        """

        self._created_at = created_at
        self._etag = etag
        self._hash = hash
        self._id = id
        self._length = length
        self._object = object
        self._status = status
        self._updated_at = updated_at
        self.discriminator = None

    @property
    def created_at(self):
        """
        Gets the created_at of this UploadChunkInfo.
        The time the entity was created

        :return: The created_at of this UploadChunkInfo.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """
        Sets the created_at of this UploadChunkInfo.
        The time the entity was created

        :param created_at: The created_at of this UploadChunkInfo.
        :type: datetime
        """

        self._created_at = created_at

    @property
    def etag(self):
        """
        Gets the etag of this UploadChunkInfo.
        API resource entity version

        :return: The etag of this UploadChunkInfo.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """
        Sets the etag of this UploadChunkInfo.
        API resource entity version

        :param etag: The etag of this UploadChunkInfo.
        :type: str
        """

        self._etag = etag

    @property
    def hash(self):
        """
        Gets the hash of this UploadChunkInfo.
        The hash of the chunk. The default hash is MD5. If no Content-MD5 header is supplied as part of uploading the chunk then this will be empty.

        :return: The hash of this UploadChunkInfo.
        :rtype: str
        """
        return self._hash

    @hash.setter
    def hash(self, hash):
        """
        Sets the hash of this UploadChunkInfo.
        The hash of the chunk. The default hash is MD5. If no Content-MD5 header is supplied as part of uploading the chunk then this will be empty.

        :param hash: The hash of this UploadChunkInfo.
        :type: str
        """

        self._hash = hash

    @property
    def id(self):
        """
        Gets the id of this UploadChunkInfo.
        The chunk number

        :return: The id of this UploadChunkInfo.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this UploadChunkInfo.
        The chunk number

        :param id: The id of this UploadChunkInfo.
        :type: int
        """

        self._id = id

    @property
    def length(self):
        """
        Gets the length of this UploadChunkInfo.
        The length of the chunk

        :return: The length of this UploadChunkInfo.
        :rtype: int
        """
        return self._length

    @length.setter
    def length(self, length):
        """
        Sets the length of this UploadChunkInfo.
        The length of the chunk

        :param length: The length of this UploadChunkInfo.
        :type: int
        """

        self._length = length

    @property
    def object(self):
        """
        Gets the object of this UploadChunkInfo.
        Entity name: always 'upload-info'

        :return: The object of this UploadChunkInfo.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object):
        """
        Sets the object of this UploadChunkInfo.
        Entity name: always 'upload-info'

        :param object: The object of this UploadChunkInfo.
        :type: str
        """

        self._object = object

    @property
    def status(self):
        """
        Gets the status of this UploadChunkInfo.
        The upload status of this chunk

        :return: The status of this UploadChunkInfo.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this UploadChunkInfo.
        The upload status of this chunk

        :param status: The status of this UploadChunkInfo.
        :type: str
        """

        self._status = status

    @property
    def updated_at(self):
        """
        Gets the updated_at of this UploadChunkInfo.
        The time the entity was updated

        :return: The updated_at of this UploadChunkInfo.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """
        Sets the updated_at of this UploadChunkInfo.
        The time the entity was updated

        :param updated_at: The updated_at of this UploadChunkInfo.
        :type: datetime
        """

        self._updated_at = updated_at

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, UploadChunkInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
